{
--------------------------------------------------------------------------------
SaveIT v1.0			saves and restores settings of CabWindows within Windows95
--------------------------------------------------------------------------------
Hook.dpr				DLL with SHELL-HOOK
--------------------------------------------------------------------------------
Last Changed:		29.08.1997
Autor:				Rudi Rahn (original by ***Arne Schpers***)
Kontakt:				soz93esw@rzaix340.rz.uni-leipzig.de
--------------------------------------------------------------------------------
Diese DLL definiert einen SHELL-HOOK, und schickt Nachrichten ber geffnete
und geschlossene Fenster an ein registriertes Fenster.
--------------------------------------------------------------------------------
Das Original dieser DLL ist von ***Arne Schpers*** (c't 6/97)
--------------------------------------------------------------------------------
For more Information see Readme.txt
--------------------------------------------------------------------------------
}

library Hook;

uses
	WinTypes, Messages;

type
	TCommonData = record
		HookID:				HHook;
		CallBackHandle:	HWnd;
	end;

const
	MapFileName		=	'HookDLL.DTA';
	ListMutexName	=	MapFileName+'Mutex';

var
	HMapFile, ListMutex:	THandle;
	CommonData:				^TCommonData;
	WM_NOTIFYSHELL:	  	Word;
   Buf:						array[0..255] of Char;

function HookFuncShell(Code: Integer; wParam: Word; lParam: LongInt): LongInt; export; stdcall;
begin
	with CommonData^ do SendMessage(CallBackHandle, WM_NOTIFYSHELL, Code, wParam);
	Result := CallNextHookEx(CommonData^.HookID, Code, wParam, lParam);
end;

function RegHlpWnd(CallbackWnd: HWnd): Boolean; export; stdcall;
begin
	try
		WaitForSingleObject(ListMutex,INFINITE);
		with CommonData^ do begin
			CallbackHandle := CallbackWnd;
			HookID			:= SetWindowsHookEx(WH_SHELL, @HookFuncShell, hInstance, 0);
			Result			:= (HookID <> 0);
		end;
	finally
		ReleaseMutex(ListMutex);
	end;
end;

procedure UnRegHlpWnd(CallbackWnd: HWnd); export; stdcall;
begin
	try
		WaitForSingleObject(ListMutex,INFINITE);
		with CommonData^ do begin
			CallbackHandle := 0;
			if (HookID <> 0) then UnHookWindowsHookEx(HookID);
		end;
	finally
		ReleaseMutex(ListMutex);
	end;
end;

procedure MapCommonData;
var FirstCall: Boolean;
begin
	ListMutex	:=	CreateMutex(nil, True, ListMutexName);
	HMapFile		:=	OpenFileMapping(FILE_MAP_WRITE, False, MapFileName);
	FirstCall	:=	(HMapFile = 0);
	if FirstCall then HMapFile	:=	CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0, SizeOf(TCommonData), MapFileName);
	CommonData	:= MapViewOfFile(HMapFile, FILE_MAP_WRITE, 0, 0, 0);
	if FirstCall then FillChar(CommonData^, SizeOf(TCommonData), 0);
	ReleaseMutex(ListMutex);
end;

exports
	RegHlpWnd  	index 1,
	UnRegHlpWnd	index 2;

begin
	MapCommonData;
	WM_NOTIFYSHELL	:= RegisterWindowMessage('NotifySHELL');
end.
